<?php
/*
Plugin Name: 123 Top-100
Plugin URI: 
Description: Top-Listen von aus.gerech.net im Blog einbinden.
Author: Ingo Henze
Version: 0.14
Author URI: http://schnurpsel.de/
*/ 

function agn_top100_read_data( $name='xovilichter' ) {
	$home = get_settings('home');
	$upload_dir = wp_upload_dir();
	$json_name = substr( wp_hash( $name ), -12, 10 );
	$file_name = $upload_dir['basedir']."/$json_name.json";
	
	$json_data = @json_decode( @file_get_contents( $file_name ), false );
	$upd_ts = @strtotime( $json_data->upd );
	$akt_ts = time();
	
	if( ($akt_ts-$upd_ts)>62*60 ) {
		$ch = curl_init( "http://aus.gerech.net/data/$name/top123.json" );
		curl_setopt( $ch, CURLOPT_USERAGENT, "Top-100 Reader/0.13 ($home)" );
		curl_setopt( $ch, CURLOPT_HEADER, false );
		curl_setopt( $ch, CURLOPT_RETURNTRANSFER, true );
		curl_setopt( $ch, CURLOPT_TIMEVALUE, @filemtime( $file_name ) );
		curl_setopt( $ch, CURLOPT_TIMECONDITION, 1 );
		$data = curl_exec( $ch );
		$info = curl_getinfo( $ch );
		curl_close( $ch );
		if( $info['http_code'] == 200 ) {
			@file_put_contents( $file_name, $data );
			$json_data = @json_decode( $data, false );
		}
	}		
	return $json_data;
}

function agn_top100_shortcode( $atts, $content = null ) {
	$symbols = array( 'txt' => '&#x2001;', 'aut' => '&#x1f464;', 'new' => '&#x1f4f0;', 'img' => '&#x1f304;', 'vid' => '&#x1f3ac;', 'lnk' => '&#x21d7;' );
	
	extract( shortcode_atts( array(
		'nam' => 'xovilichter',
		'ret' => 'rnk',
		'max' => 100,
		'dtf' => 'd.m.Y H:i',
		'lit' => 'tab',
		'cut' => 70,
		'typ' => false,
		'pos' => false,
		'sym' => true,
		'lnk' => true,
		'ltg' => false,
	), $atts ) );

	$data_name = substr( wp_hash( $nam ), -12, 10 );

	if( is_null( $GLOBALS[$data_name] ) )
		$GLOBALS[$data_name] = agn_top100_read_data( $nam );
	$top100_data = &$GLOBALS[$data_name];
	
	if( is_object( $top100_data ) ) {
		switch( $ret ) {
			case 'rnk':
				$anz = 1;
				if( $lnk && $ltg )
					$ltg_disp = " target='$ltg'";
				if( is_array( $top100_data->rnk ) ) {
					foreach( $top100_data->rnk as $num => $data ) {
						if( $typ && $typ != $data->typ )
							continue;
						if( $sym ) {
							$sym_tit = $data->typ=='img'?" title='Bild auf: {$data->url}'":'';
							$sym_tit = $data->aut==''?$sym_tit:" title='Autor: {$data->aut}'";
							$sym_css = $data->aut==''?$data->typ:'aut';
							if( $data->typ == 'txt' )
								$sym_sym = $data->aut==''?$symbols['txt']:$symbols['aut'];
							else
								$sym_sym = $symbols[$data->typ];
							$sym_disp = "<span class='sym $sym_css'$sym_tit>$sym_sym</span> ";
						}
						$url = $data->typ=='img'?$data->img:$data->url;
						$url_disp = preg_replace( '~^.+?://~i', '', $url );
						if( $cut && strlen($url_disp) > $cut )
							$url_disp = substr( $url_disp, 0, $cut ).'...';
						if( $lnk ) {
							$lnk_sym = $symbols['lnk'];
							$lnk_disp = " <a href='$url' rel='nofollow'$ltg_disp><span class='lnk'$lnk_tit>$lnk_sym</span></a>";
						}
						$pos_disp = $pos?$data->pos:$anz; 
						if( $lit == 'tab' )
							$shortcode_text .= "<tr><td class='pos'>$pos_disp</td><td class='url'>$sym_disp$url_disp$lnk_disp</td></tr>\n"; 
						else
							$shortcode_text .= "<li value='$pos_disp'>$sym_disp$url_disp$lnk_disp</li>\n"; 
						$anz++;
						if( $anz>$max )
							break;
					}
				}	
			break;	
			case 'upd':
				$date_time = strtotime( $top100_data->upd );
				$date_time += get_option( 'gmt_offset' ) * HOUR_IN_SECONDS;
				$shortcode_text = date_i18n( $dtf, $date_time ); 
			break;	
			case 'cnt':
				$shortcode_text = $top100_data->cnt; 
			break;	
			default:
				$shortcode_text = $top100_data->nam; 
			break;	
		}	
	}
	return $shortcode_text;
}

add_shortcode( 'agn_top100', 'agn_top100_shortcode' );
?>